#include <iostream>
#include <fstream>
#include <sdsl/suffix_trees.hpp>
#include <sdsl/construct.hpp>

using namespace sdsl;
using namespace std;

int main(int argc, char** argv)
{
	// Check Parameters
	if (argc!=3) {
		cout << "Usage: " << argv[0] << " inputfile outputfile" << endl;
		cout << "Stores the suffix array of inputfile to outputfile" << endl;
		return 1;
	}

	// Read text
	ifstream input(argv[1], std::ios::in|std::ios::binary|std::ios::ate);
	uint64_t n = input.tellg();
	vector<uint8_t> text(n);
	input.seekg(0);
	input.read((char*)text.data(), n);

	// Calculate SA
	vector<uint32_t> sa(n);
	divsufsort((const sauchar_t*)text.data(), (int32_t*)sa.data(), text.size());

	// Write SA
	ofstream output(argv[2]);
	output.write((char*)sa.data(), 4*sa.size());
	return 0;
}
